using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using xnalab.ddo.jp.control;
using xnalab.ddo.jp.item;
using xnalab.ddo.jp.view;
using xnalab.ddo.jp.util;

using GUISample.forms;
using GUISample.screens;

namespace GUISample
{
    /// <summary>
    /// This is the main type for your game
    /// </summary>
    public class Game1 : Game
    {
        GraphicsDeviceManager graphics;

        // r[}l[W
        ViewManager viewManager;

        // ACe}l[W
        ItemManager itemManager;

        /// <summary>
        /// RXgN^
        /// </summary>
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";

            graphics.PreferredBackBufferWidth = 640;
            graphics.PreferredBackBufferHeight = 480;

            itemManager = new ItemManager(this);
            viewManager = new ViewManager(this, graphics);

            Components.Add(itemManager);
            Components.Add(viewManager);

            IsMouseVisible = true;
        }

        /// <summary>
        /// Reg̓ǂݍ
        /// </summary>
        protected override void LoadContent()
        {
            LoginForm loginForm = new LoginForm("login");
            MainForm mainForm = new MainForm("main");
            MenuForm menuForm = new MenuForm("menu");
            viewManager.AddForm(loginForm);
            viewManager.AddForm(mainForm);
            viewManager.AddForm(menuForm);

            // ԍŏɕ\XN[ǉ
            viewManager.AddScreen(new LoginScreen(loginForm));
        }

        /// <summary>
        /// `揈
        /// </summary>
        protected override void Draw(GameTime gameTime)
        {
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            base.Draw(gameTime);
        }

        /// <summary>
        /// XV
        /// </summary>
        protected override void Update(GameTime gameTime)
        {
            base.Update(gameTime);
        }
    }

    /// <summary>
    /// The main entry point for the application.
    /// </summary>
    static class Program
    {
        [STAThreadAttribute]
        static void Main(string[] args)
        {
            using (Game1 game = new Game1())
            {
                game.Run();
            }
        }
    }
}

