using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using xnalab.ddo.jp.control;
using xnalab.ddo.jp.item;
using xnalab.ddo.jp.util;
using xnalab.ddo.jp.view;
using GUISample.screens;

namespace GUISample.forms
{
    public class MainForm : BasicForm
    {
        Color fontColor = Color.Black;

        // Rg[
        Label lblFPS;
        Label lblGuide;
        Button btnOk;
        Button btnMenu;
        Button btnBack;
        CheckBox checkBox1;
        CheckBox checkBox2;
        TextBox textbox1;
        Dialog dlgItem1;
        Dialog dlgItem2;
        Dialog dlgChat;
        ListBox lstMessage;
        // Add 2008.09.22
        ItemListBox itemList1;
        ItemListBox itemList2;

        public MainForm(string name) : base(name)
        {
            // FPS\px
            lblFPS = new Label("lblFPS", "FPS: vZ...", 10, 10, Color.White);

            // ʖ\px
            lblGuide = new Label("lblGuide", "MAIN FORM", 10, 30, Color.White);

            // `FbN{bNX
            checkBox1 = new CheckBox("check1", "ACeP", new Point(550, 10), Color.White);
            checkBox1.CheckChenged += new CheckChangedEventHandler(checkBox1_CheckChenged);
            checkBox1.AnchorLeft = false;
            checkBox1.AnchorRight = true;

            checkBox2 = new CheckBox("check2", "ACeQ", new Point(550, 30), Color.White);
            checkBox2.CheckChenged += new CheckChangedEventHandler(checkBox2_CheckChenged);
            checkBox2.AnchorLeft = false;
            checkBox2.AnchorRight = true;

            // OK{^
            btnOk = new Button("btnOk", "OK", new Rectangle(205, 160, 40, 19), fontColor);
            btnOk.MouseLeftUp += new MouseEventHandler(button_MouseUp);
            btnOk.AnchorTop = false;
            btnOk.AnchorBottom = true;
            btnOk.AnchorLeft = false;
            btnOk.AnchorRight = true;

            // Menu{^
            btnMenu = new Button("btnMenu", "MENU", new Rectangle(480, 450, 73, 21), fontColor);
            btnMenu.MouseLeftUp += new MouseEventHandler(btnMenu_MouseUp);
            btnMenu.AnchorTop = false;
            btnMenu.AnchorBottom = true;
            btnMenu.AnchorLeft = false;
            btnMenu.AnchorRight = true;
            btnMenu.Alpha = 70;

            // Back{^
            btnBack = new Button("btnBack", "BACK", new Rectangle(560, 450, 73, 21), fontColor);
            btnBack.MouseLeftUp += new MouseEventHandler(btnBack_MouseUp);
            btnBack.AnchorTop = false;
            btnBack.AnchorBottom = true;
            btnBack.AnchorLeft = false;
            btnBack.AnchorRight = true;
            btnBack.Alpha = 70;

            // bZ[WXg
            lstMessage = new ListBox("lstMessage", new Rectangle(0, 0, 250, 156), fontColor);
            lstMessage.AnchorTop = true;
            lstMessage.AnchorBottom = true;
            lstMessage.AnchorLeft = true;
            lstMessage.AnchorRight = true;

            // eLXg{bNX
            textbox1 = new TextBox("textbox1", "", new Rectangle(0, 160, 200, 19), Color.Red, fontColor, Color.White);
            textbox1.AnchorTop = false;
            textbox1.AnchorLeft = true;
            textbox1.AnchorRight = true;
            textbox1.AnchorBottom = true;

            // ACe_CAO1
            dlgItem1 = new Dialog("dlgItem1", "ACeP", fontColor, new Rectangle(240, 100, 200, 182));
            dlgItem1.Close = new MouseEventHandler(btnClose1_MouseLeftUp);
            dlgItem1.AnchorTop = false;
            dlgItem1.AnchorLeft = false;
            dlgItem1.Visible = false;

            // ACe_CAO2
            dlgItem2 = new Dialog("dlgItem2", "ACeQ", fontColor, new Rectangle(280, 140, 200, 182));
            dlgItem2.Close = new MouseEventHandler(btnClose2_MouseLeftUp);
            dlgItem2.AnchorTop = false;
            dlgItem2.AnchorLeft = false;
            dlgItem2.Visible = false;

            // `bg_CAO
            dlgChat = new Dialog("dlgChat", "`bg_CAO", fontColor, new Rectangle(0, 270, 260, 210));
            dlgChat.Alpha = 70;
            dlgChat.MinimumHeight = 150;
            dlgChat.MaximumHeight = 600;
            dlgChat.MinimumWidth = 200;
            dlgChat.MaximumWidth = 800;
            dlgChat.EnableClose = false;
            dlgChat.AnchorRight = true;
            dlgChat.AnchorBottom = true;
            dlgChat.Add(lstMessage);
            dlgChat.Add(btnOk);
            dlgChat.Add(textbox1);

            // Add 2008.09.22
            itemList1 = new ItemListBox("lstItem1", new Rectangle(0, 0, 190, 154), fontColor);
            itemList1.AnchorTop = true;
            itemList1.AnchorLeft = true;
            itemList1.AnchorBottom = true;
            itemList1.AnchorRight  = true;

            itemList2 = new ItemListBox("lstItem2", new Rectangle(0, 0, 190, 154), fontColor);
            itemList2.AnchorTop = true;
            itemList2.AnchorLeft = true;
            itemList2.AnchorBottom = true;
            itemList2.AnchorRight = true;

            // tH[ɒǉ
            this.Add(lblFPS);
            this.Add(lblGuide);
            this.Add(checkBox1);
            this.Add(checkBox2);
            this.Add(btnMenu);
            this.Add(btnBack);
            this.Add(dlgItem1);
            this.Add(dlgItem2);
            this.Add(dlgChat);

            // Add 2008.09.22
            dlgItem1.Add(itemList1);
            itemList1.Add("Xgx[");
            itemList1.Add("Xgx[");
            itemList1.Add("IW");
            itemList1.Add("IW");
            itemList1.Add("");
            itemList1.Add("");
            itemList1.Add("Abv");
            itemList1.Add("Abv");
            itemList1.Add("`F[");
            itemList1.Add("`F[");
            itemList1.Add("uhE");
            itemList1.Add("uhE");
            
            itemList2.Add("򑐂P");
            itemList2.Add("򑐂P");
            itemList2.Add("򑐂Q");
            itemList2.Add("򑐂Q");
            itemList2.Add("򑐂R");
            itemList2.Add("򑐂R");

            dlgItem2.Add(itemList2);
        }

        /// <summary>
        /// tH[ANeBu
        /// </summary>
        public override void Activate()
        {
            if (oldSize.Width != newSize.Width || oldSize.Height != newSize.Height)
            {
                string text = string.Format(
                    "𑜓x {0}~{1} ɕύX܂B", 
                    newSize.Width, newSize.Height);

                lstMessage.Add(text, Color.Green);
            }
            base.Activate();
        }

        /// <summary>
        /// _CAOP̕{^Cxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClose1_MouseLeftUp(object sender, MouseEventArgs e)
        {
            // `FbN{bNX𔽓]
            checkBox1.Checked = !checkBox1.Checked;
        }

        /// <summary>
        /// _CAOQ̕{^Cxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void btnClose2_MouseLeftUp(object sender, MouseEventArgs e)
        {
            // `FbN{bNX𔽓]
            checkBox2.Checked = !checkBox2.Checked;
        }

        /// <summary>
        /// `FbN{bNX̃`FbNCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBox1_CheckChenged(object sender, CheckChangedEventArgs e)
        {
            if (e.Check)
                dlgItem1.Focas();
        }

        /// <summary>
        /// `FbN{bNX̃`FbNCxg
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void checkBox2_CheckChenged(object sender, CheckChangedEventArgs e)
        {
            if (e.Check)
                dlgItem2.Focas();
        }

        /// <summary>
        /// Reg̓ǂݍ
        /// </summary>
        public override void LoadContent()
        {
            ContentManager content = Manager.Game.Content;

            base.LoadContent();
        }

        /// <summary>
        /// XV
        /// </summary>
        public override void Update(GameTime gameTime)
        {
            // FPSvZ
            lblFPS.Text = string.Format("FPS: {0}", ViewManager.FPS);

            // _CAOFACeP\
            if (checkBox1.Checked)
            {
                // tF[hC
                dlgItem1.Visible = true;
                if (dlgItem1.Alpha < 70)
                    dlgItem1.Alpha += 5;
            }
            else
            {
                // tF[hAEg
                if (dlgItem1.Alpha > 0)
                    dlgItem1.Alpha -= 5;
                else
                    dlgItem1.Visible = false;
            }

            // _CAOFACeQ\
            if (checkBox2.Checked)
            {
                // tF[hC
                dlgItem2.Visible = true;
                if (dlgItem2.Alpha < 70)
                    dlgItem2.Alpha += 5;
            }
            else
            {
                // tF[hAEg
                if (dlgItem2.Alpha > 0)
                    dlgItem2.Alpha -= 5;
                else
                    dlgItem2.Visible = false;
            }

            base.Update(gameTime);
        }

        /// <summary>
        /// L[Abv from BasicForm
        /// </summary>
        /// <param name="key"></param>
        public override void KeyUpHandle(Keys key)
        {
            if (key == Keys.Enter)
            {
                if (Manager.IsInputComplete && textbox1.Text.Length > 0)
                {
                    lstMessage.Add(textbox1.Text, fontColor);
                    textbox1.Text = string.Empty;
                }
            }

            base.KeyUpHandle(key);
        }

        /// <summary>
        /// {^_ECxg
        /// </summary>
        public void button_MouseUp(object sender, MouseEventArgs e)
        {
            lstMessage.Add(textbox1.Text, Color.Blue);
            textbox1.Text = string.Empty;
        }

        ///// <summary>
        ///// NA{^Cxg
        ///// </summary>
        //public void btnClear_MouseUp(object sender, MouseEventArgs e)
        //{
        //    textbox1.Text = string.Empty;
        //    lstMessage.Clear();
        //}

        /// <summary>
        /// j[{^Cxg
        /// </summary>
        public void btnMenu_MouseUp(object sender, MouseEventArgs e)
        {
            Manager.LockScreen();

            BasicForm form = Manager.GetForm("menu");
            Manager.AddScreen(new MenuScreen(form));
        }

        /// <summary>
        /// ߂{^Cxg
        /// </summary>
        public void btnBack_MouseUp(object sender, MouseEventArgs e)
        {
            BasicForm form = Manager.GetForm("login");
            Manager.ChangeScreen(new LoginScreen(form));
        }

    }
}
