using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using xnalab.ddo.jp.control;
using xnalab.ddo.jp.view;
using xnalab.ddo.jp.util;
using GUISample.screens;

namespace GUISample.forms
{
    public class MenuForm : BasicForm
    {
        Color fontColor = Color.Black;

        // Rg[
        Label lblFPS;
        Label lblGuide;
        Label lblMessage1;
        Label lblMessage2;
        Button btnOk;
        Button btnCancel;
        Dialog dlgMenu;
        CheckBox checkBox1;
        RadioButtonGroup rdoGroup1;
        RadioButton rdo1;
        RadioButton rdo2;
        RadioButton rdo3;
        RadioButton rdo4;

        RadioButtonGroup rdoGroup2;
        RadioButton rdo5;
        RadioButton rdo6;
        RadioButton rdo7;
        RadioButton rdo8;

        public MenuForm(string name)
            : base(name)
        {
            // FPS\px
            lblFPS = new Label("lblFPS", "FPS: vZ...", 10, 10, Color.White);

            // ʖ\px
            lblGuide = new Label("lblGuide", " > MENU FORM", 10, 50, Color.White);

            // `FbN{bNX
            checkBox1 = new CheckBox("check1", "tXN[", new Point(30, 10), fontColor);

            // bZ[W\px
            lblMessage1 = new Label("lblMessage1", "𑜓xI", 30, 40, fontColor);

            // WI{^
            rdoGroup1 = new RadioButtonGroup();
            rdo1 = new RadioButton("rdo1", "640 x 480", new Point(30, 60), fontColor);
            rdo2 = new RadioButton("rdo2", "800 x 600", new Point(30, 80), fontColor);
            rdo3 = new RadioButton("rdo3", "1024 x 768", new Point(30, 100), fontColor);
            rdo4 = new RadioButton("rdo4", "1280 x 1024", new Point(30, 120), fontColor);
            rdoGroup1.Add(rdo1);
            rdoGroup1.Add(rdo2);
            rdoGroup1.Add(rdo3);
            rdoGroup1.Add(rdo4);
            rdo1.Checked = true;

            // bZ[W\px
            lblMessage2 = new Label("lblMessage2", "_CAŐz", 30, 150, fontColor);

            // WI{^
            rdoGroup2 = new RadioButtonGroup();
            rdo5 = new RadioButton("rdo5", "", new Point(30, 170), fontColor);
            rdo6 = new RadioButton("rdo6", "", new Point(70, 170), fontColor);
            rdo7 = new RadioButton("rdo7", "", new Point(110, 170), fontColor);
            rdo8 = new RadioButton("rdo8", "", new Point(150, 170), fontColor);
            rdoGroup2.Add(rdo5);
            rdoGroup2.Add(rdo6);
            rdoGroup2.Add(rdo7);
            rdoGroup2.Add(rdo8);
            rdo7.Checked = true;

            // OK{^
            btnOk = new Button("btnOk", "OK", new Rectangle(30, 200, 73, 31), fontColor);
            btnOk.MouseLeftUp += new MouseEventHandler(btnOk_MouseUp);

            // CANCEL{^
            btnCancel = new Button("btnCancel", "CANCEL", new Rectangle(120, 200, 73, 31), fontColor);
            btnCancel.MouseLeftUp += new MouseEventHandler(btnCancel_MouseUp);

            // j[_CAO
            dlgMenu = new Dialog("dlgMenu", "ݒ", fontColor, new Rectangle(200, 200, 230, 270));
            dlgMenu.EnableClose = false;
            dlgMenu.EnableMove = false;
            dlgMenu.VerticalResize = false;
            dlgMenu.HorizontalResize = false;
            dlgMenu.AnchorAllClear();

            dlgMenu.Add(lblMessage1);
            dlgMenu.Add(lblMessage2);
            dlgMenu.Add(checkBox1);
            dlgMenu.Add(rdo1);
            dlgMenu.Add(rdo2);
            dlgMenu.Add(rdo3);
            dlgMenu.Add(rdo4);
            dlgMenu.Add(rdo5);
            dlgMenu.Add(rdo6);
            dlgMenu.Add(rdo7);
            dlgMenu.Add(rdo8);
            dlgMenu.Add(btnOk);
            dlgMenu.Add(btnCancel);

            Add(lblFPS);
            Add(lblGuide);
            Add(dlgMenu);
        }

        /// <summary>
        /// tH[ANeBuɕςɌĂ΂
        /// </summary>
        public override void Activate()
        {
            // _CAO^ɐݒ
            int x = (ViewManager.ViewWidth / 2) - (dlgMenu.Width / 2);
            int y = (ViewManager.ViewHeight / 2) - (dlgMenu.Height / 2);
            dlgMenu.X = x;
            dlgMenu.Y = y;
        }

        /// <summary>
        /// OK{^Cxg
        /// </summary>
        public void btnOk_MouseUp(object sender, MouseEventArgs e)
        {
            // tXN[
            Manager.FullScreen = checkBox1.Checked;

            // 𑜓x
            if (rdo1.Checked)
                // 640 x 480
                Manager.SetViewSize(640, 480);
            else if (rdo2.Checked)
                // 800 x 600
                Manager.SetViewSize(800, 600);
            else if (rdo3.Checked)
                // 1024 x 768
                Manager.SetViewSize(1024, 768);
            else if (rdo4.Checked)
                // 1280 x 1024
                Manager.SetViewSize(1280, 1024);

            // _CAO̐ڑ
            if (rdo5.Checked)
                ViewManager.Adsorption = 0;
            else if (rdo6.Checked)
                ViewManager.Adsorption = 10;
            else if (rdo7.Checked)
                ViewManager.Adsorption = 20;
            else if (rdo8.Checked)
                ViewManager.Adsorption = 30;

            Manager.ReleaseScreen();
        }

        /// <summary>
        /// CANCEL{^Cxg
        /// </summary>
        public void btnCancel_MouseUp(object sender, MouseEventArgs e)
        {
            checkBox1.Checked = Manager.FullScreen;

            if (ViewManager.ViewWidth == 640 && ViewManager.ViewHeight == 480)
                rdo1.Checked = true;
            else if (ViewManager.ViewWidth == 800 && ViewManager.ViewHeight == 600)
                rdo2.Checked = true;
            else if (ViewManager.ViewWidth == 1024 && ViewManager.ViewHeight == 768)
                rdo3.Checked = true;
            else if (ViewManager.ViewWidth == 1280 && ViewManager.ViewHeight == 1024)
                rdo4.Checked = true;

            if (ViewManager.Adsorption == 0)
                rdo5.Checked = true;
            else if (ViewManager.Adsorption == 10)
                rdo6.Checked = true;
            else if (ViewManager.Adsorption == 20)
                rdo7.Checked = true;
            else if (ViewManager.Adsorption == 30)
                rdo8.Checked = true;
            
            Manager.ReleaseScreen();
        }

        /// <summary>
        /// XV
        /// </summary>
        /// <param name="gameTime"></param>
        public override void Update(GameTime gameTime)
        {
            // FPSvZ
            lblFPS.Text = string.Format("FPS: {0}", ViewManager.FPS);

            base.Update(gameTime);
        }

    }
}
